package com.eactive.eai.agent.adapter;

import com.eactive.eai.adapter.AdapterPropManager;
import com.eactive.eai.agent.command.Command;
import com.eactive.eai.agent.command.CommandException;
import com.eactive.eai.common.util.Logger;

public class ReloadAdapterPropGroupCommand extends Command {
	private static final long serialVersionUID = 1L;

	public ReloadAdapterPropGroupCommand() {
		super("ReloadAdapterPropGroupCommand");
	}

	public Object execute() throws CommandException {
		Logger logger = Logger.getLogger(Logger.LOGGER_DEFAULT);
		if (logger.isInfo())
			logger.info(this.name + " is executed");

		if (!(args instanceof String)) {
			String rspErrorCode = "RECEAIMCM001";
			String msg = makeException(rspErrorCode, null);
			if (logger.isError())
				logger.error(msg);
			throw new CommandException(msg);
		}

		try {
			AdapterPropManager manager = AdapterPropManager.getInstance();

			String keyName = (String) args;

			if (keyName != null) {
				if ("ALL".equals(keyName)) {
					manager.reload();
					if (logger.isWarn())
						logger.warn(this.name + "] all rule Reload.");
				} else {
					manager.reload(keyName);
					if (logger.isWarn())
						logger.warn(this.name + "] " + keyName + " is Reload.");
				}
			}
		} catch (Exception e) {
			String rspErrorCode = "RECEAIMCM002";
			String msg = makeException(rspErrorCode, e);
			if (logger.isError())
				logger.error(msg, e);
			throw new CommandException(msg);
		}
		return "success";

	}

//	   public static void main(String args[]) throws Exception {
//	   test();
//}

// private static void test() throws Exception {
//        Command command = new ReloadAdapterPropGroupCommand();
//        command.setArgs("ALL");
//        AgentUtil.broadcast(command);
//    }
}
